<template>
    <div>
        <div class="operation-item" :class="{expanded: expand}">
            <div class="item checkbox" v-show="checkbox">
                <ui-checkbox v-model="item.selected" @change="updateSelectedState(item)"></ui-checkbox>
            </div>
            <template v-if="checkbox">
                <div class="item shop" v-show="showField('shop')">
                    {{item.name}}
                </div>
                <div class="item amount" v-show="showField('amount')">
                    {{item.price|currency}}
                </div>
            </template>
            <template v-else="checkbox">
                <div class="item date" v-show="showField('date')">
                    {{item.date|date}}
                </div>
                <div class="item shop" v-show="showField('shop')">
                    <template v-if="item.isRejection || item.isOperation">
                        {{item.shop.name}}
                    </template>
                    <template v-else>

                    </template>
                </div>
                <div class="item amount" v-show="showField('amount')">
                    <template v-if="item.isOperation || item.isTransaction">
                        {{item.sum|currency}} ₽
                    </template>
                    <template v-else>
                        {{item.amount|currency}} ₽
                    </template>
                </div>
                <div class="item status" v-show="showField('status')">
                    <operation-status :status="item.status"></operation-status>
                </div>
                <div class="item docs" v-show="showField('document')">
                    <SVGIcon xlink="docs-20" :fill="$theme.colors.blue" v-if="item.isOperation"
                             @click.native="downloadDocument(item)"></SVGIcon>
                    <SVGIcon xlink="collapse-20"
                             :fill="$theme.colors.gray"
                             :rotate="expand ? 180 : 0"
                             @click.native="expand = !expand"
                             :class="{right: !item.isOperation}"
                    ></SVGIcon>
                </div>
            </template>
        </div>
        <transition name="fade">
            <operation-item-details :operation="item" v-if="expand"></operation-item-details>
        </transition>
    </div>
</template>

<script>
    import OperationStatus from './operation-status.vue';
    import OperationItemDetails from './operation-item-details.vue';
    import SVGIcon from '@/components/SVGIcon';
    import dayjs from 'dayjs';
	export default {
        name: 'component-pos-operation-item',
        components: {
        	SVGIcon,
            OperationStatus,
			OperationItemDetails
        },
        props: {
			/**
             * @var {iPosOperation} item
			 */
			item: {
				type: Object,
                required: true,
            },


            fields: {
				type: Object,
                required: true,
            },

            checkbox: {
			    required: false,
                type: Boolean,
            }
        },

        data () {
        	return {
        		expand: false,
            }
        },

        filters: {
        	date(date) {
        		return dayjs(date).format('DD.MM.YYYY HH:mm')
            }
        },

        methods: {
        	showField(field) {
        		if(!this.$interface.isMobile) {
        			return true;
                }

        		return this.fields[field];
            },

            downloadDocument(/**iPosOperation**/operation) {
                this.AJAX_LOADING({
                    name: 'rootFixed',
                    isShow: true,
                    caption: 'Загрузка договора'
                });

                this.$store.dispatch('POS_GET_OPERATION_DOCUMENT', operation.loanId).then(() => {

                }).catch((e) => {
                    this.$toastr.error('Не удалось загрузить документ', 'Ошибка сервера');
                }).finally(() => {
                    this.AJAX_LOADING(false);
                });
            },

            /**
             * Обновление store.payment для данных об оплате
             * @param {iPosSale} item
             */
            updateSelectedState (item) {
        	    let ids = this.$pay.paymentValues?.ids;

        	    if(!Array.isArray(ids)) {
        	        ids = [];
                }

        	    if(item.selected) {
        	        ids.push(item.id);
                } else {
                    const index = ids.indexOf(item.id);
                    if (index !== -1) ids.splice(index, 1);
                }

        	    this.$store.commit('SET_PAYMENT', {
        	        data: {
        	            ids
                    }
                })
            }
        }
	};
</script>

<style scoped>

</style>
